/*
 * Created on May 7, 2005
 *
 *Copyright (c) 2005 The Regents of the University of Salzburg.
 *All rights reserved.
 *Permission is hereby granted, without written agreement and without
 *license or royalty fees, to use, copy, modify, and distribute this
 *software and its documentation for any purpose, provided that the above
 *copyright notice and the following two paragraphs appear in all copies
 *of this software.
 *
 *IN NO EVENT SHALL THE UNIVERSITY OF SALZBURG BE LIABLE TO ANY PARTY
 *FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 *ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 *THE UNIVERSITY OF SALZBURG HAS BEEN ADVISED OF THE POSSIBILITY OF
 *SUCH DAMAGE.

 *THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 *INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 *PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 *SALZBURG HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 *ENHANCEMENTS, OR MODIFICATIONS.
 */

package htlc;
import htlc.analysis.DepthFirstAdapter;
import htlc.node.AActuatorDeviceDriver;
import htlc.node.AModeSwitch;
import htlc.node.ASensorDeviceDriver;
import htlc.node.ATaskInvocation;
import htlc.node.NodeCast;

import java.util.Map;


/**
 * @author Daniel Iercan daniel.iercan@cs.uni-salzburg.at 2005
 *
 */
public class ModeElements extends DepthFirstAdapter {
	public final Map taskInvocations = new TypedTreeMap(StringComparator.instance,
			StringCast.instance, NodeCast.instance);
	
	public final Map modeSwitches = new TypedTreeMap(StringComparator.instance,
			StringCast.instance, NodeCast.instance);
	
	public final Map sensorDeviceDrivers = new TypedTreeMap(StringComparator.instance,
			StringCast.instance, NodeCast.instance);
	
	public final Map actuatorDeviceDrivers = new TypedTreeMap(StringComparator.instance,
			StringCast.instance, NodeCast.instance);
	
	public void outATaskInvocation(ATaskInvocation node){
		taskInvocations.put(node.getTaskName().getText(), node);
	}
	
	public void outAModeSwitch(AModeSwitch node){
		modeSwitches.put(node.getDestinationMode().getText(), node);
	}
	
	public void outASensorDeviceDriver(ASensorDeviceDriver node){
		sensorDeviceDrivers.put(node.getCommunicatorName().getText()+
				"."+node.getDriverName().getText(), node);
	}
	
	public void outAActuatorDeviceDriver(AActuatorDeviceDriver node){
		actuatorDeviceDrivers.put(node.getCommunicatorName().getText()+
				"."+node.getDriverName().getText(), node);
	}
}
