/* This file was generated by SableCC (http://www.sablecc.org/). */

package htlc.lexer;

import java.io.*;
import java.util.*;
import htlc.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TProgram(line, pos); }
    Token new1(int line, int pos) { return new TCommunicator(line, pos); }
    Token new2(int line, int pos) { return new TSensor(line, pos); }
    Token new3(int line, int pos) { return new TActuator(line, pos); }
    Token new4(int line, int pos) { return new TGeneral(line, pos); }
    Token new5(int line, int pos) { return new TPeriod(line, pos); }
    Token new6(int line, int pos) { return new TUses(line, pos); }
    Token new7(int line, int pos) { return new TModule(line, pos); }
    Token new8(int line, int pos) { return new TStart(line, pos); }
    Token new9(int line, int pos) { return new TImport(line, pos); }
    Token new10(int line, int pos) { return new TExport(line, pos); }
    Token new11(int line, int pos) { return new TTask(line, pos); }
    Token new12(int line, int pos) { return new TOutput(line, pos); }
    Token new13(int line, int pos) { return new TInput(line, pos); }
    Token new14(int line, int pos) { return new TState(line, pos); }
    Token new15(int line, int pos) { return new TParent(line, pos); }
    Token new16(int line, int pos) { return new TFunction(line, pos); }
    Token new17(int line, int pos) { return new TUpdate(line, pos); }
    Token new18(int line, int pos) { return new TPort(line, pos); }
    Token new19(int line, int pos) { return new TMode(line, pos); }
    Token new20(int line, int pos) { return new TInvoke(line, pos); }
    Token new21(int line, int pos) { return new TSwitch(line, pos); }
    Token new22(int line, int pos) { return new TWcet(line, pos); }
    Token new23(int line, int pos) { return new TInit(line, pos); }
    Token new24(int line, int pos) { return new THost(line, pos); }
    Token new25(String text, int line, int pos) { return new TIdent(text, line, pos); }
    Token new26(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new27(int line, int pos) { return new TSemicolon(line, pos); }
    Token new28(int line, int pos) { return new TComma(line, pos); }
    Token new29(int line, int pos) { return new TDot(line, pos); }
    Token new30(int line, int pos) { return new TColon(line, pos); }
    Token new31(int line, int pos) { return new TGreaterThan(line, pos); }
    Token new32(int line, int pos) { return new TLessOrEqual(line, pos); }
    Token new33(int line, int pos) { return new TAssign(line, pos); }
    Token new34(int line, int pos) { return new TLPar(line, pos); }
    Token new35(int line, int pos) { return new TRPar(line, pos); }
    Token new36(int line, int pos) { return new TLBrace(line, pos); }
    Token new37(int line, int pos) { return new TRBrace(line, pos); }
    Token new38(int line, int pos) { return new TLBracket(line, pos); }
    Token new39(int line, int pos) { return new TRBracket(line, pos); }
    Token new40(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new41(String text, int line, int pos) { return new TComment(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {40, 40, 5}, {41, 41, 6}, {44, 44, 7}, {46, 46, 8}, {47, 47, 9}, {48, 57, 10}, {58, 58, 11}, {59, 59, 12}, {60, 60, 13}, {62, 62, 14}, {65, 90, 15}, {91, 91, 16}, {93, 93, 17}, {95, 95, 18}, {97, 97, 19}, {98, 98, 20}, {99, 99, 21}, {100, 100, 20}, {101, 101, 22}, {102, 102, 23}, {103, 103, 24}, {104, 104, 25}, {105, 105, 26}, {106, 108, 20}, {109, 109, 27}, {110, 110, 20}, {111, 111, 28}, {112, 112, 29}, {113, 114, 20}, {115, 115, 30}, {116, 116, 31}, {117, 117, 32}, {118, 118, 20}, {119, 119, 33}, {120, 122, 20}, {123, 123, 34}, {125, 125, 35}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 36}, {13, 32, -2}, },
            {{9, 32, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 37}, {47, 47, 38}, },
            {{48, 57, 10}, },
            {{61, 61, 39}, },
            {},
            {{61, 61, 40}, },
            {},
            {{46, 46, 41}, {48, 57, 42}, {65, 90, 43}, {95, 95, 44}, {97, 122, 45}, },
            {},
            {},
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 98, 45}, {99, 99, 46}, {100, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 110, 45}, {111, 111, 47}, {112, 122, 45}, },
            {{46, 95, -17}, {97, 119, 45}, {120, 120, 48}, {121, 122, 45}, },
            {{46, 95, -17}, {97, 116, 45}, {117, 117, 49}, {118, 122, 45}, },
            {{46, 95, -17}, {97, 100, 45}, {101, 101, 50}, {102, 122, 45}, },
            {{46, 110, -23}, {111, 111, 51}, {112, 122, 45}, },
            {{46, 95, -17}, {97, 108, 45}, {109, 109, 52}, {110, 110, 53}, {111, 122, 45}, },
            {{46, 110, -23}, {111, 111, 54}, {112, 122, 45}, },
            {{46, 116, -25}, {117, 117, 55}, {118, 122, 45}, },
            {{46, 95, -17}, {97, 97, 56}, {98, 100, 45}, {101, 101, 57}, {102, 110, 45}, {111, 111, 58}, {112, 113, 45}, {114, 114, 59}, {115, 122, 45}, },
            {{46, 100, -26}, {101, 101, 60}, {102, 115, 45}, {116, 116, 61}, {117, 118, 45}, {119, 119, 62}, {120, 122, 45}, },
            {{46, 95, -17}, {97, 97, 63}, {98, 122, 45}, },
            {{46, 95, -17}, {97, 111, 45}, {112, 112, 64}, {113, 114, 45}, {115, 115, 65}, {116, 122, 45}, },
            {{46, 98, -21}, {99, 99, 66}, {100, 122, 45}, },
            {},
            {},
            {{9, 32, -2}, },
            {{0, 41, 67}, {42, 42, 68}, {43, 65535, 67}, },
            {{0, 9, 69}, {10, 10, 70}, {11, 12, 69}, {13, 13, 71}, {14, 65535, 69}, },
            {},
            {},
            {{65, 90, 72}, {95, 95, 73}, {97, 122, 74}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 115, 45}, {116, 116, 75}, {117, 122, 45}, },
            {{46, 108, -28}, {109, 109, 76}, {110, 122, 45}, },
            {{46, 111, -34}, {112, 112, 77}, {113, 122, 45}, },
            {{46, 95, -17}, {97, 109, 45}, {110, 110, 78}, {111, 122, 45}, },
            {{46, 109, -51}, {110, 110, 79}, {111, 122, 45}, },
            {{46, 95, -17}, {97, 114, 45}, {115, 115, 80}, {116, 122, 45}, },
            {{46, 111, -34}, {112, 112, 81}, {113, 122, 45}, },
            {{46, 95, -17}, {97, 104, 45}, {105, 105, 82}, {106, 111, 45}, {112, 112, 83}, {113, 117, 45}, {118, 118, 84}, {119, 122, 45}, },
            {{46, 95, -17}, {97, 99, 45}, {100, 100, 85}, {101, 122, 45}, },
            {{46, 115, -48}, {116, 116, 86}, {117, 122, 45}, },
            {{46, 95, -17}, {97, 113, 45}, {114, 114, 87}, {115, 122, 45}, },
            {{46, 113, -58}, {114, 114, 88}, {115, 122, 45}, },
            {{46, 113, -58}, {114, 114, 89}, {115, 122, 45}, },
            {{46, 110, -23}, {111, 111, 90}, {112, 122, 45}, },
            {{46, 109, -51}, {110, 110, 91}, {111, 122, 45}, },
            {{46, 95, -17}, {97, 97, 92}, {98, 122, 45}, },
            {{46, 104, -55}, {105, 105, 93}, {106, 122, 45}, },
            {{46, 114, -53}, {115, 115, 94}, {116, 122, 45}, },
            {{46, 99, -56}, {100, 100, 95}, {101, 122, 45}, },
            {{46, 100, -26}, {101, 101, 96}, {102, 122, 45}, },
            {{46, 100, -26}, {101, 101, 97}, {102, 122, 45}, },
            {{0, 65535, -39}, },
            {{0, 41, 98}, {42, 42, 68}, {43, 46, 98}, {47, 47, 99}, {48, 65535, 98}, },
            {{0, 65535, -40}, },
            {},
            {{10, 10, 100}, },
            {{46, 46, 41}, {48, 57, 101}, {65, 90, 102}, {95, 95, 103}, {97, 122, 104}, },
            {{46, 122, -74}, },
            {{46, 122, -74}, },
            {{46, 116, -25}, {117, 117, 105}, {118, 122, 45}, },
            {{46, 108, -28}, {109, 109, 106}, {110, 122, 45}, },
            {{46, 110, -23}, {111, 111, 107}, {112, 122, 45}, },
            {{46, 98, -21}, {99, 99, 108}, {100, 122, 45}, },
            {{46, 100, -26}, {101, 101, 109}, {102, 122, 45}, },
            {{46, 115, -48}, {116, 116, 110}, {117, 122, 45}, },
            {{46, 110, -23}, {111, 111, 111}, {112, 122, 45}, },
            {{46, 115, -48}, {116, 116, 112}, {117, 122, 45}, },
            {{46, 116, -25}, {117, 117, 113}, {118, 122, 45}, },
            {{46, 110, -23}, {111, 111, 114}, {112, 122, 45}, },
            {{46, 100, -26}, {101, 101, 115}, {102, 116, 45}, {117, 117, 116}, {118, 122, 45}, },
            {{46, 111, -34}, {112, 112, 117}, {113, 122, 45}, },
            {{46, 100, -26}, {101, 101, 118}, {102, 122, 45}, },
            {{46, 104, -55}, {105, 105, 119}, {106, 122, 45}, },
            {{46, 115, -48}, {116, 116, 120}, {117, 122, 45}, },
            {{46, 95, -17}, {97, 102, 45}, {103, 103, 121}, {104, 122, 45}, },
            {{46, 114, -53}, {115, 115, 122}, {116, 122, 45}, },
            {{46, 113, -58}, {114, 114, 123}, {115, 115, 45}, {116, 116, 124}, {117, 122, 45}, },
            {{46, 115, -48}, {116, 116, 125}, {117, 122, 45}, },
            {{46, 95, -17}, {97, 106, 45}, {107, 107, 126}, {108, 122, 45}, },
            {{46, 95, -17}, {97, 97, 127}, {98, 122, 45}, },
            {{46, 114, -53}, {115, 115, 128}, {116, 122, 45}, },
            {{46, 115, -48}, {116, 116, 129}, {117, 122, 45}, },
            {{0, 41, 130}, {42, 42, 131}, {43, 65535, 130}, },
            {},
            {},
            {{46, 122, -74}, },
            {{46, 122, -74}, },
            {{46, 122, -74}, },
            {{46, 122, -74}, },
            {{46, 95, -17}, {97, 97, 132}, {98, 122, 45}, },
            {{46, 116, -25}, {117, 117, 133}, {118, 122, 45}, },
            {{46, 113, -58}, {114, 114, 134}, {115, 122, 45}, },
            {{46, 115, -48}, {116, 116, 135}, {117, 122, 45}, },
            {{46, 113, -58}, {114, 114, 136}, {115, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 113, -58}, {114, 114, 137}, {115, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 115, -48}, {116, 116, 138}, {117, 122, 45}, },
            {{46, 106, -96}, {107, 107, 139}, {108, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 107, 45}, {108, 108, 140}, {109, 122, 45}, },
            {{46, 116, -25}, {117, 117, 141}, {118, 122, 45}, },
            {{46, 109, -51}, {110, 110, 142}, {111, 122, 45}, },
            {{46, 110, -23}, {111, 111, 143}, {112, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 113, -58}, {114, 114, 144}, {115, 122, 45}, },
            {{46, 110, -23}, {111, 111, 145}, {112, 122, 45}, },
            {{46, 115, -48}, {116, 116, 146}, {117, 122, 45}, },
            {{46, 100, -26}, {101, 101, 147}, {102, 122, 45}, },
            {{46, 98, -21}, {99, 99, 148}, {100, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 115, -48}, {116, 116, 149}, {117, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{0, 65535, -100}, },
            {{0, 41, 98}, {42, 42, 131}, {43, 65535, -70}, },
            {{46, 115, -48}, {116, 116, 150}, {117, 122, 45}, },
            {{46, 109, -51}, {110, 110, 151}, {111, 122, 45}, },
            {{46, 115, -48}, {116, 116, 152}, {117, 122, 45}, },
            {{46, 104, -55}, {105, 105, 153}, {106, 122, 45}, },
            {{46, 95, -17}, {97, 97, 154}, {98, 122, 45}, },
            {{46, 115, -48}, {116, 116, 155}, {117, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 100, -26}, {101, 101, 156}, {102, 122, 45}, },
            {{46, 100, -26}, {101, 101, 157}, {102, 122, 45}, },
            {{46, 115, -48}, {116, 116, 158}, {117, 122, 45}, },
            {{46, 115, -48}, {116, 116, 159}, {117, 122, 45}, },
            {{46, 99, -56}, {100, 100, 160}, {101, 122, 45}, },
            {{46, 95, -17}, {97, 97, 161}, {98, 122, 45}, },
            {{46, 113, -58}, {114, 114, 162}, {115, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 103, 45}, {104, 104, 163}, {105, 122, 45}, },
            {{46, 100, -26}, {101, 101, 164}, {102, 122, 45}, },
            {{46, 110, -23}, {111, 111, 165}, {112, 122, 45}, },
            {{46, 104, -55}, {105, 105, 166}, {106, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 110, -23}, {111, 111, 167}, {112, 122, 45}, },
            {{46, 107, -118}, {108, 108, 168}, {109, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 108, -28}, {109, 109, 169}, {110, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 113, -58}, {114, 114, 170}, {115, 122, 45}, },
            {{46, 98, -21}, {99, 99, 171}, {100, 122, 45}, },
            {{46, 109, -51}, {110, 110, 172}, {111, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 122, -17}, },
            {{46, 95, -17}, {97, 97, 173}, {98, 122, 45}, },
            {{46, 122, -17}, },
            {{46, 115, -48}, {116, 116, 174}, {117, 122, 45}, },
            {{46, 110, -23}, {111, 111, 175}, {112, 122, 45}, },
            {{46, 113, -58}, {114, 114, 176}, {115, 122, 45}, },
            {{46, 122, -17}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 40, 40, 40, 40, 34, 35, 28, 29, -1, 26, 30, 27, -1, 31, 25, 38, 39, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 36, 37, 40, -1, -1, 33, 32, -1, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, -1, -1, -1, 41, 41, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, -1, 41, 41, 25, 25, 25, 25, 25, 25, 25, 25, 25, 24, 25, 23, 25, 25, 19, 25, 25, 25, 25, 18, 25, 25, 25, 25, 25, 11, 25, 6, 22, -1, -1, 25, 25, 25, 25, 25, 25, 13, 25, 25, 25, 25, 25, 25, 25, 8, 14, 25, 25, 25, 25, 10, 25, 25, 9, 20, 7, 12, 15, 5, 25, 2, 21, 17, 25, 25, 25, 4, 0, 3, 25, 16, 25, 25, 25, 1, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
