/* This file was generated by SableCC (http://www.sablecc.org/). */

package htlc.parser;

import htlc.lexer.*;
import htlc.node.*;
import htlc.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(43), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(43), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(1), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(2), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(2), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(44), node, false); } break;
                    case 9: { Node node = new9(); push(goTo(44), node, false); } break;
                    case 10: { Node node = new10(); push(goTo(3), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(4), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(4), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(45), node, false); } break;
                    case 14: { Node node = new14(); push(goTo(45), node, false); } break;
                    case 15: { Node node = new15(); push(goTo(5), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(5), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(5), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(5), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(6), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(7), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(8), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(8), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(46), node, false); } break;
                    case 24: { Node node = new24(); push(goTo(46), node, false); } break;
                    case 25: { Node node = new25(); push(goTo(9), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(10), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(10), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(47), node, false); } break;
                    case 29: { Node node = new29(); push(goTo(47), node, false); } break;
                    case 30: { Node node = new30(); push(goTo(11), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(11), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(11), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(11), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(12), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(13), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(14), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(14), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(15), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(15), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(48), node, false); } break;
                    case 41: { Node node = new41(); push(goTo(48), node, false); } break;
                    case 42: { Node node = new42(); push(goTo(16), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(17), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(18), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(18), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(19), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(19), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(49), node, false); } break;
                    case 49: { Node node = new49(); push(goTo(49), node, false); } break;
                    case 50: { Node node = new50(); push(goTo(20), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(21), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(22), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(22), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(50), node, false); } break;
                    case 55: { Node node = new55(); push(goTo(50), node, false); } break;
                    case 56: { Node node = new56(); push(goTo(23), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(23), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(24), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(25), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(25), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(51), node, false); } break;
                    case 62: { Node node = new62(); push(goTo(51), node, false); } break;
                    case 63: { Node node = new63(); push(goTo(26), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(27), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(27), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(52), node, false); } break;
                    case 67: { Node node = new67(); push(goTo(52), node, false); } break;
                    case 68: { Node node = new68(); push(goTo(28), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(29), node, true); } break;
                    case 70: { Node node = new70(); push(goTo(29), node, true); } break;
                    case 71: { Node node = new71(); push(goTo(53), node, false); } break;
                    case 72: { Node node = new72(); push(goTo(53), node, false); } break;
                    case 73: { Node node = new73(); push(goTo(30), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(30), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(31), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(32), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(32), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(33), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(33), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(54), node, false); } break;
                    case 81: { Node node = new81(); push(goTo(54), node, false); } break;
                    case 82: { Node node = new82(); push(goTo(34), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(35), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(35), node, true); } break;
                    case 85: { Node node = new85(); push(goTo(36), node, true); } break;
                    case 86: { Node node = new86(); push(goTo(37), node, true); } break;
                    case 87: { Node node = new87(); push(goTo(37), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(55), node, false); } break;
                    case 89: { Node node = new89(); push(goTo(55), node, false); } break;
                    case 90: { Node node = new90(); push(goTo(38), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(39), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(39), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(40), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(40), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(56), node, false); } break;
                    case 96: { Node node = new96(); push(goTo(56), node, false); } break;
                    case 97: { Node node = new97(); push(goTo(41), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(42), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProgramDeclarationList node1 = (PProgramDeclarationList) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        XPProgramDeclaration node1 = null;
        AProgramDeclarationList node = new AProgramDeclarationList(node1);
        return node;
    }

    Node new1()
    {
        XPProgramDeclaration node1 = (XPProgramDeclaration) pop();
        AProgramDeclarationList node = new AProgramDeclarationList(node1);
        return node;
    }

    Node new2()
    {
        PProgramDeclaration node2 = (PProgramDeclaration) pop();
        XPProgramDeclaration node1 = (XPProgramDeclaration) pop();
        X1PProgramDeclaration node = new X1PProgramDeclaration(node1, node2);
        return node;
    }

    Node new3()
    {
        PProgramDeclaration node1 = (PProgramDeclaration) pop();
        X2PProgramDeclaration node = new X2PProgramDeclaration(node1);
        return node;
    }

    Node new4()
    {
        TRBrace node6 = (TRBrace) pop();
        PModuleDeclarationList node5 = (PModuleDeclarationList) pop();
        PCommunicatorDeclarationList node4 = null;
        TLBrace node3 = (TLBrace) pop();
        TIdent node2 = (TIdent) pop();
        TProgram node1 = (TProgram) pop();
        AProgramDeclaration node = new AProgramDeclaration(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new5()
    {
        TRBrace node6 = (TRBrace) pop();
        PModuleDeclarationList node5 = (PModuleDeclarationList) pop();
        PCommunicatorDeclarationList node4 = (PCommunicatorDeclarationList) pop();
        TLBrace node3 = (TLBrace) pop();
        TIdent node2 = (TIdent) pop();
        TProgram node1 = (TProgram) pop();
        AProgramDeclaration node = new AProgramDeclaration(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new6()
    {
        XPCommunicatorDeclaration node2 = null;
        TCommunicator node1 = (TCommunicator) pop();
        ACommunicatorDeclarationList node = new ACommunicatorDeclarationList(node1, node2);
        return node;
    }

    Node new7()
    {
        XPCommunicatorDeclaration node2 = (XPCommunicatorDeclaration) pop();
        TCommunicator node1 = (TCommunicator) pop();
        ACommunicatorDeclarationList node = new ACommunicatorDeclarationList(node1, node2);
        return node;
    }

    Node new8()
    {
        PCommunicatorDeclaration node2 = (PCommunicatorDeclaration) pop();
        XPCommunicatorDeclaration node1 = (XPCommunicatorDeclaration) pop();
        X1PCommunicatorDeclaration node = new X1PCommunicatorDeclaration(node1, node2);
        return node;
    }

    Node new9()
    {
        PCommunicatorDeclaration node1 = (PCommunicatorDeclaration) pop();
        X2PCommunicatorDeclaration node = new X2PCommunicatorDeclaration(node1);
        return node;
    }

    Node new10()
    {
        TSemicolon node7 = (TSemicolon) pop();
        TIdent node6 = (TIdent) pop();
        TInit node5 = (TInit) pop();
        TNumber node4 = (TNumber) pop();
        TPeriod node3 = (TPeriod) pop();
        TIdent node2 = (TIdent) pop();
        TIdent node1 = (TIdent) pop();
        ACommunicatorDeclaration node = new ACommunicatorDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new11()
    {
        XPModuleDeclaration node1 = null;
        AModuleDeclarationList node = new AModuleDeclarationList(node1);
        return node;
    }

    Node new12()
    {
        XPModuleDeclaration node1 = (XPModuleDeclaration) pop();
        AModuleDeclarationList node = new AModuleDeclarationList(node1);
        return node;
    }

    Node new13()
    {
        PModuleDeclaration node2 = (PModuleDeclaration) pop();
        XPModuleDeclaration node1 = (XPModuleDeclaration) pop();
        X1PModuleDeclaration node = new X1PModuleDeclaration(node1, node2);
        return node;
    }

    Node new14()
    {
        PModuleDeclaration node1 = (PModuleDeclaration) pop();
        X2PModuleDeclaration node = new X2PModuleDeclaration(node1);
        return node;
    }

    Node new15()
    {
        TRBrace node10 = (TRBrace) pop();
        PModeDeclarationList node9 = (PModeDeclarationList) pop();
        PTaskDeclarationList node8 = (PTaskDeclarationList) pop();
        PPortDeclarationList node7 = null;
        TLBrace node6 = (TLBrace) pop();
        TIdent node5 = (TIdent) pop();
        TStart node4 = (TStart) pop();
        PHostDeclaration node3 = null;
        TIdent node2 = (TIdent) pop();
        TModule node1 = (TModule) pop();
        AModuleDeclaration node = new AModuleDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new16()
    {
        TRBrace node10 = (TRBrace) pop();
        PModeDeclarationList node9 = (PModeDeclarationList) pop();
        PTaskDeclarationList node8 = (PTaskDeclarationList) pop();
        PPortDeclarationList node7 = null;
        TLBrace node6 = (TLBrace) pop();
        TIdent node5 = (TIdent) pop();
        TStart node4 = (TStart) pop();
        PHostDeclaration node3 = (PHostDeclaration) pop();
        TIdent node2 = (TIdent) pop();
        TModule node1 = (TModule) pop();
        AModuleDeclaration node = new AModuleDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new17()
    {
        TRBrace node10 = (TRBrace) pop();
        PModeDeclarationList node9 = (PModeDeclarationList) pop();
        PTaskDeclarationList node8 = (PTaskDeclarationList) pop();
        PPortDeclarationList node7 = (PPortDeclarationList) pop();
        TLBrace node6 = (TLBrace) pop();
        TIdent node5 = (TIdent) pop();
        TStart node4 = (TStart) pop();
        PHostDeclaration node3 = null;
        TIdent node2 = (TIdent) pop();
        TModule node1 = (TModule) pop();
        AModuleDeclaration node = new AModuleDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new18()
    {
        TRBrace node10 = (TRBrace) pop();
        PModeDeclarationList node9 = (PModeDeclarationList) pop();
        PTaskDeclarationList node8 = (PTaskDeclarationList) pop();
        PPortDeclarationList node7 = (PPortDeclarationList) pop();
        TLBrace node6 = (TLBrace) pop();
        TIdent node5 = (TIdent) pop();
        TStart node4 = (TStart) pop();
        PHostDeclaration node3 = (PHostDeclaration) pop();
        TIdent node2 = (TIdent) pop();
        TModule node1 = (TModule) pop();
        AModuleDeclaration node = new AModuleDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new19()
    {
        TRBracket node6 = (TRBracket) pop();
        TNumber node5 = (TNumber) pop();
        TColon node4 = (TColon) pop();
        PIpDeclaration node3 = (PIpDeclaration) pop();
        TIdent node2 = (TIdent) pop();
        TLBracket node1 = (TLBracket) pop();
        AHostDeclaration node = new AHostDeclaration(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new20()
    {
        TNumber node7 = (TNumber) pop();
        TDot node6 = (TDot) pop();
        TNumber node5 = (TNumber) pop();
        TDot node4 = (TDot) pop();
        TNumber node3 = (TNumber) pop();
        TDot node2 = (TDot) pop();
        TNumber node1 = (TNumber) pop();
        AIpDeclaration node = new AIpDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new21()
    {
        XPPortDeclaration node2 = null;
        TPort node1 = (TPort) pop();
        APortDeclarationList node = new APortDeclarationList(node1, node2);
        return node;
    }

    Node new22()
    {
        XPPortDeclaration node2 = (XPPortDeclaration) pop();
        TPort node1 = (TPort) pop();
        APortDeclarationList node = new APortDeclarationList(node1, node2);
        return node;
    }

    Node new23()
    {
        PPortDeclaration node2 = (PPortDeclaration) pop();
        XPPortDeclaration node1 = (XPPortDeclaration) pop();
        X1PPortDeclaration node = new X1PPortDeclaration(node1, node2);
        return node;
    }

    Node new24()
    {
        PPortDeclaration node1 = (PPortDeclaration) pop();
        X2PPortDeclaration node = new X2PPortDeclaration(node1);
        return node;
    }

    Node new25()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TIdent node4 = (TIdent) pop();
        TAssign node3 = (TAssign) pop();
        TIdent node2 = (TIdent) pop();
        TIdent node1 = (TIdent) pop();
        APortDeclaration node = new APortDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new26()
    {
        XPTaskDeclaration node1 = null;
        ATaskDeclarationList node = new ATaskDeclarationList(node1);
        return node;
    }

    Node new27()
    {
        XPTaskDeclaration node1 = (XPTaskDeclaration) pop();
        ATaskDeclarationList node = new ATaskDeclarationList(node1);
        return node;
    }

    Node new28()
    {
        PTaskDeclaration node2 = (PTaskDeclaration) pop();
        XPTaskDeclaration node1 = (XPTaskDeclaration) pop();
        X1PTaskDeclaration node = new X1PTaskDeclaration(node1, node2);
        return node;
    }

    Node new29()
    {
        PTaskDeclaration node1 = (PTaskDeclaration) pop();
        X2PTaskDeclaration node = new X2PTaskDeclaration(node1);
        return node;
    }

    Node new30()
    {
        TSemicolon node11 = (TSemicolon) pop();
        PTaskWcet node10 = null;
        PTaskFunction node9 = null;
        PFormalPorts node8 = (PFormalPorts) pop();
        TOutput node7 = (TOutput) pop();
        PStatePorts node6 = (PStatePorts) pop();
        TState node5 = (TState) pop();
        PFormalPorts node4 = (PFormalPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TTask node1 = (TTask) pop();
        ATaskDeclaration node = new ATaskDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new31()
    {
        TSemicolon node11 = (TSemicolon) pop();
        PTaskWcet node10 = null;
        PTaskFunction node9 = (PTaskFunction) pop();
        PFormalPorts node8 = (PFormalPorts) pop();
        TOutput node7 = (TOutput) pop();
        PStatePorts node6 = (PStatePorts) pop();
        TState node5 = (TState) pop();
        PFormalPorts node4 = (PFormalPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TTask node1 = (TTask) pop();
        ATaskDeclaration node = new ATaskDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new32()
    {
        TSemicolon node11 = (TSemicolon) pop();
        PTaskWcet node10 = (PTaskWcet) pop();
        PTaskFunction node9 = null;
        PFormalPorts node8 = (PFormalPorts) pop();
        TOutput node7 = (TOutput) pop();
        PStatePorts node6 = (PStatePorts) pop();
        TState node5 = (TState) pop();
        PFormalPorts node4 = (PFormalPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TTask node1 = (TTask) pop();
        ATaskDeclaration node = new ATaskDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new33()
    {
        TSemicolon node11 = (TSemicolon) pop();
        PTaskWcet node10 = (PTaskWcet) pop();
        PTaskFunction node9 = (PTaskFunction) pop();
        PFormalPorts node8 = (PFormalPorts) pop();
        TOutput node7 = (TOutput) pop();
        PStatePorts node6 = (PStatePorts) pop();
        TState node5 = (TState) pop();
        PFormalPorts node4 = (PFormalPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TTask node1 = (TTask) pop();
        ATaskDeclaration node = new ATaskDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new34()
    {
        TIdent node2 = (TIdent) pop();
        TFunction node1 = (TFunction) pop();
        ATaskFunction node = new ATaskFunction(node1, node2);
        return node;
    }

    Node new35()
    {
        TNumber node2 = (TNumber) pop();
        TWcet node1 = (TWcet) pop();
        ATaskWcet node = new ATaskWcet(node1, node2);
        return node;
    }

    Node new36()
    {
        TRPar node3 = (TRPar) pop();
        PFormalPortList node2 = null;
        TLPar node1 = (TLPar) pop();
        AFormalPorts node = new AFormalPorts(node1, node2, node3);
        return node;
    }

    Node new37()
    {
        TRPar node3 = (TRPar) pop();
        PFormalPortList node2 = (PFormalPortList) pop();
        TLPar node1 = (TLPar) pop();
        AFormalPorts node = new AFormalPorts(node1, node2, node3);
        return node;
    }

    Node new38()
    {
        XPFormalPortTail node2 = null;
        PFormalPort node1 = (PFormalPort) pop();
        AConcreteFormalPortList node = new AConcreteFormalPortList(node1, node2);
        return node;
    }

    Node new39()
    {
        XPFormalPortTail node2 = (XPFormalPortTail) pop();
        PFormalPort node1 = (PFormalPort) pop();
        AConcreteFormalPortList node = new AConcreteFormalPortList(node1, node2);
        return node;
    }

    Node new40()
    {
        PFormalPortTail node2 = (PFormalPortTail) pop();
        XPFormalPortTail node1 = (XPFormalPortTail) pop();
        X1PFormalPortTail node = new X1PFormalPortTail(node1, node2);
        return node;
    }

    Node new41()
    {
        PFormalPortTail node1 = (PFormalPortTail) pop();
        X2PFormalPortTail node = new X2PFormalPortTail(node1);
        return node;
    }

    Node new42()
    {
        PFormalPort node2 = (PFormalPort) pop();
        TComma node1 = (TComma) pop();
        AFormalPortTail node = new AFormalPortTail(node1, node2);
        return node;
    }

    Node new43()
    {
        TIdent node2 = (TIdent) pop();
        TIdent node1 = (TIdent) pop();
        AFormalPort node = new AFormalPort(node1, node2);
        return node;
    }

    Node new44()
    {
        TRPar node3 = (TRPar) pop();
        PStatePortList node2 = null;
        TLPar node1 = (TLPar) pop();
        AStatePorts node = new AStatePorts(node1, node2, node3);
        return node;
    }

    Node new45()
    {
        TRPar node3 = (TRPar) pop();
        PStatePortList node2 = (PStatePortList) pop();
        TLPar node1 = (TLPar) pop();
        AStatePorts node = new AStatePorts(node1, node2, node3);
        return node;
    }

    Node new46()
    {
        XPStatePortTail node2 = null;
        PStatePort node1 = (PStatePort) pop();
        AConcreteStatePortList node = new AConcreteStatePortList(node1, node2);
        return node;
    }

    Node new47()
    {
        XPStatePortTail node2 = (XPStatePortTail) pop();
        PStatePort node1 = (PStatePort) pop();
        AConcreteStatePortList node = new AConcreteStatePortList(node1, node2);
        return node;
    }

    Node new48()
    {
        PStatePortTail node2 = (PStatePortTail) pop();
        XPStatePortTail node1 = (XPStatePortTail) pop();
        X1PStatePortTail node = new X1PStatePortTail(node1, node2);
        return node;
    }

    Node new49()
    {
        PStatePortTail node1 = (PStatePortTail) pop();
        X2PStatePortTail node = new X2PStatePortTail(node1);
        return node;
    }

    Node new50()
    {
        PStatePort node2 = (PStatePort) pop();
        TComma node1 = (TComma) pop();
        AStatePortTail node = new AStatePortTail(node1, node2);
        return node;
    }

    Node new51()
    {
        TIdent node4 = (TIdent) pop();
        TAssign node3 = (TAssign) pop();
        TIdent node2 = (TIdent) pop();
        TIdent node1 = (TIdent) pop();
        AStatePort node = new AStatePort(node1, node2, node3, node4);
        return node;
    }

    Node new52()
    {
        XPModeDeclaration node1 = null;
        AModeDeclarationList node = new AModeDeclarationList(node1);
        return node;
    }

    Node new53()
    {
        XPModeDeclaration node1 = (XPModeDeclaration) pop();
        AModeDeclarationList node = new AModeDeclarationList(node1);
        return node;
    }

    Node new54()
    {
        PModeDeclaration node2 = (PModeDeclaration) pop();
        XPModeDeclaration node1 = (XPModeDeclaration) pop();
        X1PModeDeclaration node = new X1PModeDeclaration(node1, node2);
        return node;
    }

    Node new55()
    {
        PModeDeclaration node1 = (PModeDeclaration) pop();
        X2PModeDeclaration node = new X2PModeDeclaration(node1);
        return node;
    }

    Node new56()
    {
        TRBrace node11 = (TRBrace) pop();
        PModeSwitchList node10 = (PModeSwitchList) pop();
        PTaskInvocationList node9 = (PTaskInvocationList) pop();
        PActuatorDeviceDriverList node8 = (PActuatorDeviceDriverList) pop();
        PSensorDeviceDriverList node7 = (PSensorDeviceDriverList) pop();
        TLBrace node6 = (TLBrace) pop();
        PRefineProgram node5 = null;
        TNumber node4 = (TNumber) pop();
        TPeriod node3 = (TPeriod) pop();
        TIdent node2 = (TIdent) pop();
        TMode node1 = (TMode) pop();
        AModeDeclaration node = new AModeDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new57()
    {
        TRBrace node11 = (TRBrace) pop();
        PModeSwitchList node10 = (PModeSwitchList) pop();
        PTaskInvocationList node9 = (PTaskInvocationList) pop();
        PActuatorDeviceDriverList node8 = (PActuatorDeviceDriverList) pop();
        PSensorDeviceDriverList node7 = (PSensorDeviceDriverList) pop();
        TLBrace node6 = (TLBrace) pop();
        PRefineProgram node5 = (PRefineProgram) pop();
        TNumber node4 = (TNumber) pop();
        TPeriod node3 = (TPeriod) pop();
        TIdent node2 = (TIdent) pop();
        TMode node1 = (TMode) pop();
        AModeDeclaration node = new AModeDeclaration(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, node11);
        return node;
    }

    Node new58()
    {
        TIdent node2 = (TIdent) pop();
        TProgram node1 = (TProgram) pop();
        ARefineProgram node = new ARefineProgram(node1, node2);
        return node;
    }

    Node new59()
    {
        XPSensorDeviceDriver node1 = null;
        ASensorDeviceDriverList node = new ASensorDeviceDriverList(node1);
        return node;
    }

    Node new60()
    {
        XPSensorDeviceDriver node1 = (XPSensorDeviceDriver) pop();
        ASensorDeviceDriverList node = new ASensorDeviceDriverList(node1);
        return node;
    }

    Node new61()
    {
        PSensorDeviceDriver node2 = (PSensorDeviceDriver) pop();
        XPSensorDeviceDriver node1 = (XPSensorDeviceDriver) pop();
        X1PSensorDeviceDriver node = new X1PSensorDeviceDriver(node1, node2);
        return node;
    }

    Node new62()
    {
        PSensorDeviceDriver node1 = (PSensorDeviceDriver) pop();
        X2PSensorDeviceDriver node = new X2PSensorDeviceDriver(node1);
        return node;
    }

    Node new63()
    {
        TSemicolon node9 = (TSemicolon) pop();
        TRPar node8 = (TRPar) pop();
        TNumber node7 = (TNumber) pop();
        TComma node6 = (TComma) pop();
        TIdent node5 = (TIdent) pop();
        TLPar node4 = (TLPar) pop();
        TIdent node3 = (TIdent) pop();
        TUpdate node2 = (TUpdate) pop();
        TSensor node1 = (TSensor) pop();
        ASensorDeviceDriver node = new ASensorDeviceDriver(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new64()
    {
        XPActuatorDeviceDriver node1 = null;
        AActuatorDeviceDriverList node = new AActuatorDeviceDriverList(node1);
        return node;
    }

    Node new65()
    {
        XPActuatorDeviceDriver node1 = (XPActuatorDeviceDriver) pop();
        AActuatorDeviceDriverList node = new AActuatorDeviceDriverList(node1);
        return node;
    }

    Node new66()
    {
        PActuatorDeviceDriver node2 = (PActuatorDeviceDriver) pop();
        XPActuatorDeviceDriver node1 = (XPActuatorDeviceDriver) pop();
        X1PActuatorDeviceDriver node = new X1PActuatorDeviceDriver(node1, node2);
        return node;
    }

    Node new67()
    {
        PActuatorDeviceDriver node1 = (PActuatorDeviceDriver) pop();
        X2PActuatorDeviceDriver node = new X2PActuatorDeviceDriver(node1);
        return node;
    }

    Node new68()
    {
        TSemicolon node9 = (TSemicolon) pop();
        TRPar node8 = (TRPar) pop();
        TNumber node7 = (TNumber) pop();
        TComma node6 = (TComma) pop();
        TIdent node5 = (TIdent) pop();
        TLPar node4 = (TLPar) pop();
        TIdent node3 = (TIdent) pop();
        TUpdate node2 = (TUpdate) pop();
        TActuator node1 = (TActuator) pop();
        AActuatorDeviceDriver node = new AActuatorDeviceDriver(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new69()
    {
        XPTaskInvocation node1 = null;
        ATaskInvocationList node = new ATaskInvocationList(node1);
        return node;
    }

    Node new70()
    {
        XPTaskInvocation node1 = (XPTaskInvocation) pop();
        ATaskInvocationList node = new ATaskInvocationList(node1);
        return node;
    }

    Node new71()
    {
        PTaskInvocation node2 = (PTaskInvocation) pop();
        XPTaskInvocation node1 = (XPTaskInvocation) pop();
        X1PTaskInvocation node = new X1PTaskInvocation(node1, node2);
        return node;
    }

    Node new72()
    {
        PTaskInvocation node1 = (PTaskInvocation) pop();
        X2PTaskInvocation node = new X2PTaskInvocation(node1);
        return node;
    }

    Node new73()
    {
        TSemicolon node8 = (TSemicolon) pop();
        PParentTask node7 = null;
        PActualPorts node6 = (PActualPorts) pop();
        TOutput node5 = (TOutput) pop();
        PActualPorts node4 = (PActualPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TInvoke node1 = (TInvoke) pop();
        ATaskInvocation node = new ATaskInvocation(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new74()
    {
        TSemicolon node8 = (TSemicolon) pop();
        PParentTask node7 = (PParentTask) pop();
        PActualPorts node6 = (PActualPorts) pop();
        TOutput node5 = (TOutput) pop();
        PActualPorts node4 = (PActualPorts) pop();
        TInput node3 = (TInput) pop();
        TIdent node2 = (TIdent) pop();
        TInvoke node1 = (TInvoke) pop();
        ATaskInvocation node = new ATaskInvocation(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new75()
    {
        TIdent node2 = (TIdent) pop();
        TParent node1 = (TParent) pop();
        AParentTask node = new AParentTask(node1, node2);
        return node;
    }

    Node new76()
    {
        TRPar node3 = (TRPar) pop();
        PActualPortList node2 = null;
        TLPar node1 = (TLPar) pop();
        AActualPorts node = new AActualPorts(node1, node2, node3);
        return node;
    }

    Node new77()
    {
        TRPar node3 = (TRPar) pop();
        PActualPortList node2 = (PActualPortList) pop();
        TLPar node1 = (TLPar) pop();
        AActualPorts node = new AActualPorts(node1, node2, node3);
        return node;
    }

    Node new78()
    {
        XPActualPortTail node2 = null;
        PActualPort node1 = (PActualPort) pop();
        AConcreteActualPortList node = new AConcreteActualPortList(node1, node2);
        return node;
    }

    Node new79()
    {
        XPActualPortTail node2 = (XPActualPortTail) pop();
        PActualPort node1 = (PActualPort) pop();
        AConcreteActualPortList node = new AConcreteActualPortList(node1, node2);
        return node;
    }

    Node new80()
    {
        PActualPortTail node2 = (PActualPortTail) pop();
        XPActualPortTail node1 = (XPActualPortTail) pop();
        X1PActualPortTail node = new X1PActualPortTail(node1, node2);
        return node;
    }

    Node new81()
    {
        PActualPortTail node1 = (PActualPortTail) pop();
        X2PActualPortTail node = new X2PActualPortTail(node1);
        return node;
    }

    Node new82()
    {
        PActualPort node2 = (PActualPort) pop();
        TComma node1 = (TComma) pop();
        AActualPortTail node = new AActualPortTail(node1, node2);
        return node;
    }

    Node new83()
    {
        TIdent node1 = (TIdent) pop();
        AConcreteActualPort node = new AConcreteActualPort(node1);
        return node;
    }

    Node new84()
    {
        PCommunicatorInstance node1 = (PCommunicatorInstance) pop();
        AActualPort node = new AActualPort(node1);
        return node;
    }

    Node new85()
    {
        TRPar node5 = (TRPar) pop();
        TNumber node4 = (TNumber) pop();
        TComma node3 = (TComma) pop();
        TIdent node2 = (TIdent) pop();
        TLPar node1 = (TLPar) pop();
        ACommunicatorInstance node = new ACommunicatorInstance(node1, node2, node3, node4, node5);
        return node;
    }

    Node new86()
    {
        XPModeSwitch node1 = null;
        AModeSwitchList node = new AModeSwitchList(node1);
        return node;
    }

    Node new87()
    {
        XPModeSwitch node1 = (XPModeSwitch) pop();
        AModeSwitchList node = new AModeSwitchList(node1);
        return node;
    }

    Node new88()
    {
        PModeSwitch node2 = (PModeSwitch) pop();
        XPModeSwitch node1 = (XPModeSwitch) pop();
        X1PModeSwitch node = new X1PModeSwitch(node1, node2);
        return node;
    }

    Node new89()
    {
        PModeSwitch node1 = (PModeSwitch) pop();
        X2PModeSwitch node = new X2PModeSwitch(node1);
        return node;
    }

    Node new90()
    {
        TSemicolon node7 = (TSemicolon) pop();
        TIdent node6 = (TIdent) pop();
        TRPar node5 = (TRPar) pop();
        PSwitchPorts node4 = (PSwitchPorts) pop();
        TIdent node3 = (TIdent) pop();
        TLPar node2 = (TLPar) pop();
        TSwitch node1 = (TSwitch) pop();
        AModeSwitch node = new AModeSwitch(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new91()
    {
        TRPar node3 = (TRPar) pop();
        PSwitchPortList node2 = null;
        TLPar node1 = (TLPar) pop();
        ASwitchPorts node = new ASwitchPorts(node1, node2, node3);
        return node;
    }

    Node new92()
    {
        TRPar node3 = (TRPar) pop();
        PSwitchPortList node2 = (PSwitchPortList) pop();
        TLPar node1 = (TLPar) pop();
        ASwitchPorts node = new ASwitchPorts(node1, node2, node3);
        return node;
    }

    Node new93()
    {
        XPSwitchPortTail node2 = null;
        PSwitchPort node1 = (PSwitchPort) pop();
        AConcreteSwitchPortList node = new AConcreteSwitchPortList(node1, node2);
        return node;
    }

    Node new94()
    {
        XPSwitchPortTail node2 = (XPSwitchPortTail) pop();
        PSwitchPort node1 = (PSwitchPort) pop();
        AConcreteSwitchPortList node = new AConcreteSwitchPortList(node1, node2);
        return node;
    }

    Node new95()
    {
        PSwitchPortTail node2 = (PSwitchPortTail) pop();
        XPSwitchPortTail node1 = (XPSwitchPortTail) pop();
        X1PSwitchPortTail node = new X1PSwitchPortTail(node1, node2);
        return node;
    }

    Node new96()
    {
        PSwitchPortTail node1 = (PSwitchPortTail) pop();
        X2PSwitchPortTail node = new X2PSwitchPortTail(node1);
        return node;
    }

    Node new97()
    {
        PSwitchPort node2 = (PSwitchPort) pop();
        TComma node1 = (TComma) pop();
        ASwitchPortTail node = new ASwitchPortTail(node1, node2);
        return node;
    }

    Node new98()
    {
        TIdent node1 = (TIdent) pop();
        ASwitchPort node = new ASwitchPort(node1);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 0}, {0, SHIFT, 1}, },
			{{-1, ERROR, 1}, {25, SHIFT, 5}, },
			{{-1, ERROR, 2}, {40, ACCEPT, -1}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, },
			{{-1, ERROR, 5}, {36, SHIFT, 7}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 11}, {1, SHIFT, 8}, {7, SHIFT, 9}, },
			{{-1, REDUCE, 6}, {25, SHIFT, 14}, },
			{{-1, ERROR, 9}, {25, SHIFT, 17}, },
			{{-1, REDUCE, 11}, {7, SHIFT, 9}, },
			{{-1, ERROR, 11}, {37, SHIFT, 19}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 12}, {7, SHIFT, 9}, },
			{{-1, ERROR, 14}, {25, SHIFT, 21}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 7}, {25, SHIFT, 14}, },
			{{-1, ERROR, 17}, {8, SHIFT, 23}, {38, SHIFT, 24}, },
			{{-1, ERROR, 18}, {37, SHIFT, 26}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 21}, {5, SHIFT, 27}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 23}, {25, SHIFT, 28}, },
			{{-1, ERROR, 24}, {25, SHIFT, 29}, },
			{{-1, ERROR, 25}, {8, SHIFT, 30}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 27}, {26, SHIFT, 31}, },
			{{-1, ERROR, 28}, {36, SHIFT, 32}, },
			{{-1, ERROR, 29}, {26, SHIFT, 33}, },
			{{-1, ERROR, 30}, {25, SHIFT, 35}, },
			{{-1, ERROR, 31}, {23, SHIFT, 36}, },
			{{-1, REDUCE, 26}, {11, SHIFT, 37}, {18, SHIFT, 38}, },
			{{-1, ERROR, 33}, {29, SHIFT, 43}, },
			{{-1, ERROR, 34}, {30, SHIFT, 44}, },
			{{-1, ERROR, 35}, {36, SHIFT, 45}, },
			{{-1, ERROR, 36}, {25, SHIFT, 46}, },
			{{-1, ERROR, 37}, {25, SHIFT, 47}, },
			{{-1, REDUCE, 21}, {25, SHIFT, 48}, },
			{{-1, REDUCE, 26}, {11, SHIFT, 37}, },
			{{-1, REDUCE, 52}, {19, SHIFT, 52}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 27}, {11, SHIFT, 37}, },
			{{-1, ERROR, 43}, {26, SHIFT, 57}, },
			{{-1, ERROR, 44}, {26, SHIFT, 58}, },
			{{-1, REDUCE, 26}, {11, SHIFT, 37}, {18, SHIFT, 38}, },
			{{-1, ERROR, 46}, {27, SHIFT, 61}, },
			{{-1, ERROR, 47}, {13, SHIFT, 62}, },
			{{-1, ERROR, 48}, {25, SHIFT, 63}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 22}, {25, SHIFT, 48}, },
			{{-1, REDUCE, 52}, {19, SHIFT, 52}, },
			{{-1, ERROR, 52}, {25, SHIFT, 66}, },
			{{-1, ERROR, 53}, {37, SHIFT, 67}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 53}, {19, SHIFT, 52}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 57}, {29, SHIFT, 69}, },
			{{-1, ERROR, 58}, {39, SHIFT, 70}, },
			{{-1, REDUCE, 26}, {11, SHIFT, 37}, },
			{{-1, REDUCE, 52}, {19, SHIFT, 52}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 62}, {34, SHIFT, 73}, },
			{{-1, ERROR, 63}, {33, SHIFT, 75}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 65}, {37, SHIFT, 76}, },
			{{-1, ERROR, 66}, {5, SHIFT, 77}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 69}, {26, SHIFT, 78}, },
			{{-1, REDUCE, 19}, },
			{{-1, REDUCE, 52}, {19, SHIFT, 52}, },
			{{-1, ERROR, 72}, {37, SHIFT, 80}, },
			{{-1, ERROR, 73}, {25, SHIFT, 81}, {35, SHIFT, 82}, },
			{{-1, ERROR, 74}, {14, SHIFT, 85}, },
			{{-1, ERROR, 75}, {25, SHIFT, 86}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 77}, {26, SHIFT, 87}, },
			{{-1, ERROR, 78}, {29, SHIFT, 88}, },
			{{-1, ERROR, 79}, {37, SHIFT, 89}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 81}, {25, SHIFT, 90}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 83}, {35, SHIFT, 91}, },
			{{-1, REDUCE, 38}, {28, SHIFT, 92}, },
			{{-1, ERROR, 85}, {34, SHIFT, 95}, },
			{{-1, ERROR, 86}, {27, SHIFT, 97}, },
			{{-1, ERROR, 87}, {0, SHIFT, 98}, {36, SHIFT, 99}, },
			{{-1, ERROR, 88}, {26, SHIFT, 101}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 37}, },
			{{-1, ERROR, 92}, {25, SHIFT, 81}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 39}, {28, SHIFT, 92}, },
			{{-1, ERROR, 95}, {25, SHIFT, 104}, {35, SHIFT, 105}, },
			{{-1, ERROR, 96}, {12, SHIFT, 108}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 98}, {25, SHIFT, 109}, },
			{{-1, REDUCE, 59}, {2, SHIFT, 110}, },
			{{-1, ERROR, 100}, {36, SHIFT, 114}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 42}, },
			{{-1, REDUCE, 40}, },
			{{-1, ERROR, 104}, {25, SHIFT, 115}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 106}, {35, SHIFT, 116}, },
			{{-1, REDUCE, 46}, {28, SHIFT, 117}, },
			{{-1, ERROR, 108}, {34, SHIFT, 73}, },
			{{-1, REDUCE, 58}, },
			{{-1, ERROR, 110}, {17, SHIFT, 121}, },
			{{-1, REDUCE, 64}, {3, SHIFT, 122}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 60}, {2, SHIFT, 110}, },
			{{-1, REDUCE, 59}, {2, SHIFT, 110}, },
			{{-1, ERROR, 115}, {33, SHIFT, 128}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 117}, {25, SHIFT, 104}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 47}, {28, SHIFT, 117}, },
			{{-1, ERROR, 120}, {16, SHIFT, 131}, {22, SHIFT, 132}, {27, SHIFT, 133}, },
			{{-1, ERROR, 121}, {25, SHIFT, 136}, },
			{{-1, ERROR, 122}, {17, SHIFT, 137}, },
			{{-1, REDUCE, 69}, {20, SHIFT, 138}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 65}, {3, SHIFT, 122}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 64}, {3, SHIFT, 122}, },
			{{-1, ERROR, 128}, {25, SHIFT, 144}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 131}, {25, SHIFT, 145}, },
			{{-1, ERROR, 132}, {26, SHIFT, 146}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 134}, {22, SHIFT, 132}, {27, SHIFT, 147}, },
			{{-1, ERROR, 135}, {27, SHIFT, 149}, },
			{{-1, ERROR, 136}, {34, SHIFT, 150}, },
			{{-1, ERROR, 137}, {25, SHIFT, 151}, },
			{{-1, ERROR, 138}, {25, SHIFT, 152}, },
			{{-1, REDUCE, 86}, {21, SHIFT, 153}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 70}, {20, SHIFT, 138}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 69}, {20, SHIFT, 138}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 148}, {27, SHIFT, 159}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 150}, {25, SHIFT, 160}, },
			{{-1, ERROR, 151}, {34, SHIFT, 161}, },
			{{-1, ERROR, 152}, {13, SHIFT, 162}, },
			{{-1, ERROR, 153}, {34, SHIFT, 163}, },
			{{-1, ERROR, 154}, {37, SHIFT, 164}, },
			{{-1, REDUCE, 89}, },
			{{-1, REDUCE, 87}, {21, SHIFT, 153}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 86}, {21, SHIFT, 153}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 160}, {28, SHIFT, 167}, },
			{{-1, ERROR, 161}, {25, SHIFT, 168}, },
			{{-1, ERROR, 162}, {34, SHIFT, 169}, },
			{{-1, ERROR, 163}, {25, SHIFT, 171}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 88}, },
			{{-1, ERROR, 166}, {37, SHIFT, 172}, },
			{{-1, ERROR, 167}, {26, SHIFT, 173}, },
			{{-1, ERROR, 168}, {28, SHIFT, 174}, },
			{{-1, ERROR, 169}, {25, SHIFT, 175}, {34, SHIFT, 176}, {35, SHIFT, 177}, },
			{{-1, ERROR, 170}, {12, SHIFT, 181}, },
			{{-1, ERROR, 171}, {34, SHIFT, 182}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 173}, {35, SHIFT, 184}, },
			{{-1, ERROR, 174}, {26, SHIFT, 185}, },
			{{-1, REDUCE, 83}, },
			{{-1, ERROR, 176}, {25, SHIFT, 186}, },
			{{-1, REDUCE, 76}, },
			{{-1, ERROR, 178}, {35, SHIFT, 187}, },
			{{-1, REDUCE, 78}, {28, SHIFT, 188}, },
			{{-1, REDUCE, 84}, },
			{{-1, ERROR, 181}, {34, SHIFT, 169}, },
			{{-1, ERROR, 182}, {25, SHIFT, 192}, {35, SHIFT, 193}, },
			{{-1, ERROR, 183}, {35, SHIFT, 196}, },
			{{-1, ERROR, 184}, {27, SHIFT, 197}, },
			{{-1, ERROR, 185}, {35, SHIFT, 198}, },
			{{-1, ERROR, 186}, {28, SHIFT, 199}, },
			{{-1, REDUCE, 77}, },
			{{-1, ERROR, 188}, {25, SHIFT, 175}, {34, SHIFT, 176}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 79}, {28, SHIFT, 188}, },
			{{-1, ERROR, 191}, {15, SHIFT, 202}, {27, SHIFT, 203}, },
			{{-1, REDUCE, 98}, },
			{{-1, REDUCE, 91}, },
			{{-1, ERROR, 194}, {35, SHIFT, 205}, },
			{{-1, REDUCE, 93}, {28, SHIFT, 206}, },
			{{-1, ERROR, 196}, {25, SHIFT, 209}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 198}, {27, SHIFT, 210}, },
			{{-1, ERROR, 199}, {26, SHIFT, 211}, },
			{{-1, REDUCE, 82}, },
			{{-1, REDUCE, 80}, },
			{{-1, ERROR, 202}, {25, SHIFT, 212}, },
			{{-1, REDUCE, 73}, },
			{{-1, ERROR, 204}, {27, SHIFT, 213}, },
			{{-1, REDUCE, 92}, },
			{{-1, ERROR, 206}, {25, SHIFT, 192}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 94}, {28, SHIFT, 206}, },
			{{-1, ERROR, 209}, {27, SHIFT, 216}, },
			{{-1, REDUCE, 68}, },
			{{-1, ERROR, 211}, {35, SHIFT, 217}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 97}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 85}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 2}, },
			{{-1, 3}, {4, 6}, },
			{{-1, 10}, },
			{{-1, 15}, {16, 22}, },
			{{-1, 11}, {10, 18}, },
			{{-1, 12}, {13, 20}, },
			{{-1, 25}, },
			{{-1, 34}, },
			{{-1, 39}, {45, 59}, },
			{{-1, 49}, {50, 64}, },
			{{-1, 40}, {39, 51}, {45, 60}, {59, 71}, },
			{{-1, 41}, {42, 56}, },
			{{-1, 134}, },
			{{-1, 135}, {134, 148}, },
			{{-1, 74}, {108, 120}, },
			{{-1, 83}, },
			{{-1, 93}, {94, 103}, },
			{{-1, 84}, {92, 102}, },
			{{-1, 96}, },
			{{-1, 106}, },
			{{-1, 118}, {119, 130}, },
			{{-1, 107}, {117, 129}, },
			{{-1, 53}, {51, 65}, {60, 72}, {71, 79}, },
			{{-1, 54}, {55, 68}, },
			{{-1, 100}, },
			{{-1, 111}, {114, 127}, },
			{{-1, 112}, {113, 126}, },
			{{-1, 123}, {127, 143}, },
			{{-1, 124}, {125, 142}, },
			{{-1, 139}, {143, 158}, },
			{{-1, 140}, {141, 157}, },
			{{-1, 204}, },
			{{-1, 170}, {181, 191}, },
			{{-1, 178}, },
			{{-1, 189}, {190, 201}, },
			{{-1, 179}, {188, 200}, },
			{{-1, 180}, },
			{{-1, 154}, {158, 166}, },
			{{-1, 155}, {156, 165}, },
			{{-1, 183}, },
			{{-1, 194}, },
			{{-1, 207}, {208, 215}, },
			{{-1, 195}, {206, 214}, },
			{{-1, 4}, },
			{{-1, 16}, },
			{{-1, 13}, },
			{{-1, 50}, },
			{{-1, 42}, },
			{{-1, 94}, },
			{{-1, 119}, },
			{{-1, 55}, },
			{{-1, 113}, },
			{{-1, 125}, },
			{{-1, 141}, },
			{{-1, 190}, },
			{{-1, 156}, },
			{{-1, 208}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'program', EOF",
			"expecting: ident",
			"expecting: EOF",
			"expecting: '{'",
			"expecting: 'communicator', 'module', '}'",
			"expecting: 'module', ident, '}'",
			"expecting: 'module', '}'",
			"expecting: '}'",
			"expecting: 'start', '['",
			"expecting: 'period'",
			"expecting: 'start'",
			"expecting: number",
			"expecting: 'init'",
			"expecting: 'task', 'port', 'mode', '}'",
			"expecting: '.'",
			"expecting: ':'",
			"expecting: 'task', 'mode', ident, '}'",
			"expecting: 'task', 'mode', '}'",
			"expecting: 'mode', '}'",
			"expecting: ';'",
			"expecting: 'input'",
			"expecting: ']'",
			"expecting: '('",
			"expecting: ':='",
			"expecting: ident, ')'",
			"expecting: 'state'",
			"expecting: 'state', 'function', 'wcet', ';'",
			"expecting: ')'",
			"expecting: ',', ')'",
			"expecting: 'program', '{'",
			"expecting: 'output'",
			"expecting: 'sensor', 'actuator', 'invoke', 'switch', '}'",
			"expecting: 'update'",
			"expecting: 'actuator', 'invoke', 'switch', '}'",
			"expecting: 'function', 'wcet', ';'",
			"expecting: 'invoke', 'switch', '}'",
			"expecting: 'wcet', ';'",
			"expecting: 'switch', '}'",
			"expecting: ','",
			"expecting: ident, '(', ')'",
			"expecting: 'output', 'parent', ';'",
			"expecting: ident, '('",
			"expecting: 'parent', ';'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 0, 0, 3, 0, 4, 5, 1, 6, 7, 6, 6, 1, 5, 5, 8, 7, 0, 6, 9, 5, 1, 1, 10, 0, 11, 3, 11, 1, 12, 13, 14, 15, 3, 1, 1, 16, 17, 18, 17, 17, 11, 11, 13, 19, 20, 1, 16, 16, 18, 1, 7, 18, 18, 17, 14, 21, 17, 18, 5, 22, 23, 16, 7, 9, 6, 18, 11, 10, 18, 7, 24, 25, 1, 6, 11, 14, 7, 6, 1, 26, 27, 28, 22, 19, 29, 11, 6, 28, 26, 1, 28, 28, 24, 30, 16, 1, 31, 3, 15, 28, 28, 1, 30, 27, 28, 22, 3, 32, 33, 31, 31, 31, 23, 30, 1, 28, 28, 34, 1, 32, 35, 33, 33, 31, 33, 1, 28, 28, 1, 11, 17, 36, 19, 22, 1, 1, 37, 35, 35, 33, 35, 28, 36, 19, 17, 19, 17, 1, 22, 20, 22, 7, 37, 37, 35, 37, 17, 38, 1, 22, 1, 18, 37, 7, 11, 38, 39, 30, 22, 18, 27, 11, 28, 1, 40, 27, 28, 28, 22, 24, 27, 19, 27, 38, 40, 41, 28, 28, 42, 28, 27, 27, 28, 1, 31, 19, 11, 28, 28, 1, 35, 19, 27, 1, 28, 28, 19, 33, 27, 19, 35, 28, 28, 37, 28, 
        };*/
}
